## vxl 1.17.0.dfsg2

=== CMakeLists.txt ===
#
# Root vxl
#
#   geoff.cross@crd.ge.com

CMAKE_MINIMUM_REQUIRED(VERSION 2.4.5)

# Support for CMake 2.6
IF( COMMAND CMAKE_POLICY )
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF( COMMAND CMAKE_POLICY )

PROJECT(vxl)

SET( LIBRARY_OUTPUT_PATH ${vxl_BINARY_DIR}/lib CACHE PATH
     "Output directory for the vxl libraries" )

IF( NOT EXECUTABLE_OUTPUT_PATH )
    SET( EXECUTABLE_OUTPUT_PATH "." )
ENDIF( NOT EXECUTABLE_OUTPUT_PATH )


# CMake support directory.
SET(VXL_CMAKE_DIR ${vxl_SOURCE_DIR}/config/cmake/Modules)

INCLUDE( ${VXL_CMAKE_DIR}/VXLStandardOptions.cmake )
INCLUDE( ${vxl_SOURCE_DIR}/config/cmake/config/vxl_utils.cmake )
# INCLUDE( ${vxl_SOURCE_DIR}/UseSTLPort.cmake )
INCLUDE(${vxl_SOURCE_DIR}/config/cmake/doxygen/doxygen.cmake)

# Copy the UseVXL.cmake file to the binary directory so that client
# projects don't need to find the source directory first. They can run
# the UseVXL.cmake from the vxl binary directory, and determine the
# vxl source directory by loading the cache.
CONFIGURE_FILE( ${VXL_CMAKE_DIR}/UseVXL.cmake
                ${vxl_BINARY_DIR}/UseVXL.cmake COPYONLY )

# Copy CTestCustom.cmake to top of build tree
CONFIGURE_FILE( ${VXL_CMAKE_DIR}/CTestCustom.cmake
  ${vxl_BINARY_DIR}/CTestCustom.cmake COPYONLY )

# Location of VXL's FindXXX.cmake CMake modules.
# This is identical to VXL_CMAKE_DIR.  Perhaps we should eliminate MODULE_PATH?
SET( MODULE_PATH ${vxl_SOURCE_DIR}/config/cmake/Modules CACHE STATIC "VXL module path" )

# For use in client projects that call UseVXL.cmake
SET (VXL_LIBRARY_PATH ${LIBRARY_OUTPUT_PATH} CACHE STATIC "Where all the vxl libraries are, for clients to use." )

# Options to add extra compiler and linker flags
#
# These options allow you to specify additional flags without
# affecting the default flags for a particular platform or build type.
# This is especially useful for adding extra warning flags.
SET( VXL_EXTRA_CMAKE_C_FLAGS             CACHE STRING "Extra flags appended to CMAKE_C_FLAGS" )
SET( VXL_EXTRA_CMAKE_CXX_FLAGS           CACHE STRING "Extra flags appended to CMAKE_CXX_FLAGS" )
SET( VXL_EXTRA_CMAKE_EXE_LINKER_FLAGS    CACHE STRING "Extra flags appended to CMAKE_EXE_LINKER_FLAGS" )
SET( VXL_EXTRA_CMAKE_MODULE_LINKER_FLAGS CACHE STRING "Extra flags appended to CMAKE_MODULE_LINKER_FLAGS" )
SET( VXL_EXTRA_CMAKE_SHARED_LINKER_FLAGS CACHE STRING "Extra flags appended to CMAKE_SHARED_LINKER_FLAGS" )
SET( CMAKE_C_FLAGS             "${CMAKE_C_FLAGS} ${VXL_EXTRA_CMAKE_C_FLAGS}" )
SET( CMAKE_CXX_FLAGS           "${CMAKE_CXX_FLAGS} ${VXL_EXTRA_CMAKE_CXX_FLAGS}" )
SET( CMAKE_EXE_LINKER_FLAGS    "${CMAKE_EXE_LINKER_FLAGS} ${VXL_EXTRA_CMAKE_EXE_LINKER_FLAGS}" )
SET( CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${VXL_EXTRA_CMAKE_MODULE_LINKER_FLAGS}" )
SET( CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${VXL_EXTRA_CMAKE_SHARED_LINKER_FLAGS}" )


# Option to specify whether this is a build for the dashboard.  Each
# dashboard build should set BUILD_FOR_VXL_DASHBOARD to YES in the
# initial cache (set in the CTest script).
OPTION( BUILD_FOR_VXL_DASHBOARD "Is this a build for the dashboard?" NO )

# A variable to default some OPTIONs to YES for the dashboard, but to
# NO for other builds.
IF( BUILD_FOR_VXL_DASHBOARD )
  SET( YES_FOR_DASHBOARD "YES" )
ELSE( BUILD_FOR_VXL_DASHBOARD )
  SET( YES_FOR_DASHBOARD "NO" )
ENDIF( BUILD_FOR_VXL_DASHBOARD )


# Do platform-specific configuration.
IF(NOT VXL_NO_CMAKE_CONFIGURE)
  SUBDIRS(config/cmake/config)
ENDIF(NOT VXL_NO_CMAKE_CONFIGURE)


# Options to reduce build to just some core libraries
OPTION( BUILD_CORE_NUMERICS "Build VXL's numerics libraries" YES )
OPTION( BUILD_CORE_SERIALISATION "Build VXL's serialisation libraries" YES )
OPTION( BUILD_CORE_UTILITIES "Build VXL's utility libraries" YES )
OPTION( BUILD_CORE_GEOMETRY "Build VXL's geometry libraries" YES )
OPTION( BUILD_CORE_IMAGING "Build VXL's imaging libraries" YES )
IF(BUILD_CORE_NUMERICS)
  IF( BUILD_FOR_VXL_DASHBOARD )
    OPTION( BUILD_CORE_PROBABILITY "Build VXL's probability libraries (Experimental)" YES )
  ELSE( BUILD_FOR_VXL_DASHBOARD )
    OPTION( BUILD_CORE_PROBABILITY "Build VXL's probability libraries (Experimental)" NO )
  ENDIF( BUILD_FOR_VXL_DASHBOARD )
ENDIF(BUILD_CORE_NUMERICS)
SET (BUILD_CORE_ALL OFF CACHE INTERNAL "All Core libraries are being built")
IF (BUILD_CORE_GEOMETRY AND BUILD_CORE_NUMERICS)
  IF (BUILD_CORE_UTILITIES AND BUILD_CORE_SERIALISATION)
    IF (BUILD_CORE_IMAGING)
      SET (BUILD_CORE_ALL ON CACHE INTERNAL "All Core libraries are being built")
    ENDIF (BUILD_CORE_IMAGING)
  ENDIF (BUILD_CORE_UTILITIES AND BUILD_CORE_SERIALISATION)
ENDIF (BUILD_CORE_GEOMETRY AND BUILD_CORE_NUMERICS)

# Optionally use old error reporting methods, rather than exceptions.
# The main use is in vil which often uses/used null images to imply an error.
OPTION (VXL_LEGACY_ERROR_REPORTING "Use old error reporting methods rather than exceptions?" YES)
IF (VXL_LEGACY_ERROR_REPORTING)
  ADD_DEFINITIONS( -DVXL_LEGACY_ERROR_REPORTING )
ENDIF (VXL_LEGACY_ERROR_REPORTING)



# Options to build no longer maintained libraries.
# It is still useful to have the dashboard check that they are correct,
# but no-one is likely to work on improving test coverage or fixing memory leaks.
OPTION( BUILD_UNMAINTAINED_LIBRARIES "Build libraries that are no longer actively maintained?" ${YES_FOR_DASHBOARD} )

# Option to build Windows Unicode support, the string
# type of which is wchar_t, each character is a 16-bit unsigned integer. 
# 
IF(WIN32)
  IF(VXL_HAS_WIN_WCHAR_T)
    OPTION( VXL_USE_WIN_WCHAR_T "Build overloading functions that accept Windows wide char strings?" YES )
    IF(VXL_USE_WIN_WCHAR_T)   # Force it to be 0/1
      SET(VXL_USE_WIN_WCHAR_T 1)
    ELSE(VXL_USE_WIN_WCHAR_T)
      SET(VXL_USE_WIN_WCHAR_T 0)
    ENDIF(VXL_USE_WIN_WCHAR_T)
  ELSE(VXL_HAS_WIN_WCHAR_T)
    SET(VXL_USE_WIN_WCHAR_T 0)
  ENDIF(VXL_HAS_WIN_WCHAR_T)
ELSE(WIN32)
  # avoid empty macro definition
  SET(VXL_USE_WIN_WCHAR_T 0)
ENDIF(WIN32)

# Build the core vxl + support libraries
SUBDIRS(vcl v3p core)

# Optionally build the contributed libraries
IF( EXISTS ${vxl_SOURCE_DIR}/contrib/CMakeLists.txt )
  OPTION( BUILD_CONTRIB "Build the contributed libraries?" YES )
ENDIF( EXISTS ${vxl_SOURCE_DIR}/contrib/CMakeLists.txt )

IF( BUILD_CONTRIB AND BUILD_CORE_ALL)
  SUBDIRS( contrib )
ENDIF( BUILD_CONTRIB AND BUILD_CORE_ALL)

# Use the old configure script if the cache tells us to do so.
IF(VXL_NO_CMAKE_CONFIGURE)
  IF(RUN_CONFIGURE)
    EXEC_PROGRAM( ${vxl_SOURCE_DIR}/configure
      ${vxl_BINARY_DIR} )
  ENDIF(RUN_CONFIGURE)
ENDIF(VXL_NO_CMAKE_CONFIGURE)

# Some types of path names can cause havoc with regular expressions,
# so avoid those.
IF( ${vxl_BINARY_DIR} MATCHES  \\+ )
  MESSAGE(SEND_ERROR "You cannot have a + in your binary path")
ENDIF( ${vxl_BINARY_DIR} MATCHES  \\+ )
IF( ${vxl_SOURCE_DIR} MATCHES  \\+ )
  MESSAGE(SEND_ERROR "You cannot have a + in your source path")
ENDIF( ${vxl_SOURCE_DIR} MATCHES  \\+ )

# include CMakeListsLocal.txt from source directory if it exists
# also include it from the binary dir if different from source dir
IF( ${vxl_BINARY_DIR} MATCHES ${vxl_SOURCE_DIR} )
  INCLUDE( ${vxl_SOURCE_DIR}/CMakeListsLocal.txt OPTIONAL )
ELSE( ${vxl_BINARY_DIR} MATCHES ${vxl_SOURCE_DIR} )
  INCLUDE( ${vxl_SOURCE_DIR}/CMakeListsLocal.txt OPTIONAL )
  INCLUDE( ${vxl_BINARY_DIR}/CMakeListsLocal.txt OPTIONAL )
ENDIF( ${vxl_BINARY_DIR} MATCHES ${vxl_SOURCE_DIR} )

# Standard include directories.
SET(VXLCORE_INCLUDE_DIR ${vxl_BINARY_DIR}/core ${vxl_SOURCE_DIR}/core)
SET(VXLCORE_INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_PREFIX}/include/vxl/core)
SET(VCL_INCLUDE_DIR ${vxl_BINARY_DIR}/vcl ${vxl_SOURCE_DIR}/vcl)
SET(VCL_INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_PREFIX}/include/vxl/vcl)

# Autoconf does not work on windows.  Use hardcoded results if not using
# cmake to configure.
IF(VXL_NO_CMAKE_CONFIGURE)
  IF(WIN32)
    IF(NOT CYGWIN)
      SET(VCL_INCLUDE_DIR ${vxl_SOURCE_DIR}/vcl/config.win32 ${VCL_INCLUDE_DIR})
      SET(VCL_INSTALL_INCLUDE_DIR 
        ${CMAKE_INSTALL_PREFIX}/include/vcl/config.win32
        ${VCL_INSTALL_INCLUDE_DIR}
      )
    ENDIF(NOT CYGWIN)
  ENDIF(WIN32)
ENDIF(VXL_NO_CMAKE_CONFIGURE)

INCLUDE_DIRECTORIES(${VCL_INCLUDE_DIR} ${VXLCORE_INCLUDE_DIR})

# This SUBDIRS command must be the last SUBDIRS command in this file
SUBDIRS( config/cmake/export )

=== contrib/CMakeLists.txt ===
# This is contrib/CMakeLists.txt
# Dependencies: mul --> (rpl,tbl);  oxl --> gel --> brl;  (gel,oxl) --> conversions

IF( EXISTS ${vxl_SOURCE_DIR}/contrib/conversions/CMakeLists.txt )
  OPTION(BUILD_CONVERSIONS "Build the Conversions Examples?" YES)
ENDIF( EXISTS ${vxl_SOURCE_DIR}/contrib/conversions/CMakeLists.txt )

IF( EXISTS ${vxl_SOURCE_DIR}/contrib/brl/CMakeLists.txt )
  OPTION(BUILD_BRL "Build the Brown University library package?" YES)
ENDIF( EXISTS ${vxl_SOURCE_DIR}/contrib/brl/CMakeLists.txt )

IF( EXISTS ${vxl_SOURCE_DIR}/contrib/gel/CMakeLists.txt )
  OPTION(BUILD_GEL "Build the GE library package?" YES)
ENDIF( EXISTS ${vxl_SOURCE_DIR}/contrib/gel/CMakeLists.txt )

IF( EXISTS ${vxl_SOURCE_DIR}/contrib/mul/CMakeLists.txt )
  OPTION(BUILD_MUL "Build the Manchester University library package?" YES)
ENDIF( EXISTS ${vxl_SOURCE_DIR}/contrib/mul/CMakeLists.txt )

IF( EXISTS ${vxl_SOURCE_DIR}/contrib/oul/CMakeLists.txt )
  OPTION(BUILD_OUL "Build the Otago University library package?" YES)
ENDIF( EXISTS ${vxl_SOURCE_DIR}/contrib/oul/CMakeLists.txt )

IF( EXISTS ${vxl_SOURCE_DIR}/contrib/prip/CMakeLists.txt )
  OPTION(BUILD_PRIP "Build the T.U.Wien library package?" YES)
ENDIF( EXISTS ${vxl_SOURCE_DIR}/contrib/prip/CMakeLists.txt )

IF( EXISTS ${vxl_SOURCE_DIR}/contrib/oxl/CMakeLists.txt )
  OPTION(BUILD_OXL "Build the Oxford University library package?" YES)
ENDIF( EXISTS ${vxl_SOURCE_DIR}/contrib/oxl/CMakeLists.txt )

IF( EXISTS ${vxl_SOURCE_DIR}/contrib/rpl/CMakeLists.txt )
  OPTION(BUILD_RPL "Build the RPI library package?" YES)
ENDIF( EXISTS ${vxl_SOURCE_DIR}/contrib/rpl/CMakeLists.txt )

IF( EXISTS ${vxl_SOURCE_DIR}/contrib/tbl/CMakeLists.txt )
  OPTION(BUILD_TBL "Build the TB library package?" YES)
ENDIF( EXISTS ${vxl_SOURCE_DIR}/contrib/tbl/CMakeLists.txt )

IF( EXISTS ${vxl_SOURCE_DIR}/contrib/cul/CMakeLists.txt )
    OPTION(BUILD_CUL "Build the Cornell University library package?" NO)
ENDIF( EXISTS ${vxl_SOURCE_DIR}/contrib/cul/CMakeLists.txt )


IF(BUILD_MUL)
  SUBDIRS(mul)
ENDIF(BUILD_MUL)

IF(BUILD_RPL)
  SUBDIRS(rpl)
ENDIF(BUILD_RPL)

IF(BUILD_TBL)
  SUBDIRS(tbl)
ENDIF(BUILD_TBL)

IF(BUILD_OUL)
  SUBDIRS(oul)
ENDIF(BUILD_OUL)

IF(BUILD_OXL)
  SUBDIRS(oxl)
ENDIF(BUILD_OXL)

IF(BUILD_GEL)
  SUBDIRS(gel)
ENDIF(BUILD_GEL)

IF(BUILD_BRL)
  SUBDIRS(brl)
  IF(BUILD_GEL)
  # since gel/vsrl depends on brl/bseg/sdet, it cannot be built before brl:
  IF (BUILD_UNMAINTAINED_LIBRARIES OR BUILD_FOR_VXL_DASHBOARD)
    # Dense matcher
    SUBDIRS(gel/vsrl)
  ENDIF (BUILD_UNMAINTAINED_LIBRARIES OR BUILD_FOR_VXL_DASHBOARD)
  IF (BUILD_TESTING)
    # since gel/vifa/tests depends on brl/bseg/sdet, it must be built after brl:
    SUBDIRS(gel/vifa/tests)
  ENDIF (BUILD_TESTING)
  ENDIF(BUILD_GEL)
ENDIF(BUILD_BRL)

IF(BUILD_PRIP)
  SUBDIRS(prip)
ENDIF(BUILD_PRIP)

IF(BUILD_CONVERSIONS)
  SUBDIRS(conversions)
ENDIF(BUILD_CONVERSIONS)

IF(BUILD_CUL)
  SUBDIRS(cul)
ENDIF(BUILD_CUL)

=== contrib/conversions/CMakeLists.txt ===
PROJECT( conversions )

SET( CONVERSIONS_INCLUDE_DIR ${conversions_SOURCE_DIR} CACHE STATIC "Conversions Examples package include files" )
SET( CONVERSIONS_INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_PREFIX}/include/vxl/contrib/conversions CACHE INTERNAL "Conversions Examples package include files" )

INCLUDE_DIRECTORIES( ${VXLCORE_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${CONVERSIONS_INCLUDE_DIR} )

SUBDIRS(container geometry image math misc)

=== contrib/gel/CMakeLists.txt ===
# ./gel/CMakeLists.txt

PROJECT( gel )

doxygen_add_package(contrib/gel "GE Libraries")

SET( GEL_INCLUDE_DIR ${gel_SOURCE_DIR} CACHE STATIC "GE package include files" )
SET( GEL_INSTALL_INCLUDE_DIR 
  ${CMAKE_INSTALL_PREFIX}/include/vxl/contrib/gel
  CACHE INTERNAL "GE package include files"
)

INCLUDE_DIRECTORIES( ${VXLCORE_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${GEL_INCLUDE_DIR} )

# spatial objects
SUBDIRS(vsol)

# digital  geometry
SUBDIRS(vdgl)

# topology
SUBDIRS(vtol gst)

# van-duc region finder (ported from TargetJr)
SUBDIRS(gevd)

# matcher
SUBDIRS(geml)

# Multi-view database
SUBDIRS(gmvl)

# Kanade-Lucas-Tomasi feature tracker;
IF (BUILD_UNMAINTAINED_LIBRARIES OR BUILD_FOR_VXL_DASHBOARD)
  SUBDIRS(vgel/kl vgel gkll)
ENDIF (BUILD_UNMAINTAINED_LIBRARIES OR BUILD_FOR_VXL_DASHBOARD)

# Dense matcher
SUBDIRS(vmal)

# Triangulation code
SUBDIRS(gtrl)

# octree stuff from Geoff's thesis
IF(BUILD_OXL)
  SUBDIRS(octree)
ENDIF(BUILD_OXL)

# photogrammetry in mrc/vpgl,
# coordinate systems add-on in mrc/vcsl
SUBDIRS(mrc)

# Intensity face attributes (MPP)
SUBDIRS(vifa)

=== contrib/mul/CMakeLists.txt ===
# ./mul/CMakeLists.txt

PROJECT( mul )

doxygen_add_book(contrib/mul
  "Manchester University Library overview documentation")

doxygen_add_package(contrib/mul "Manchester University Libraries")

SET( VXL_MUL_INCLUDE_DIR ${mul_SOURCE_DIR} CACHE STATIC "Manchester University package include files" )
SET( MUL_INCLUDE_DIR ${VXL_MUL_INCLUDE_DIR} CACHE STATIC "Deprecated variable giving Manchester University package include files" )
SET( MUL_INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_PREFIX}/include/vxl/contrib/mul CACHE INTERNAL "Manchester University package includes install path" )

INCLUDE_DIRECTORIES( ${VXLCORE_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${VXL_MUL_INCLUDE_DIR} )


SUBDIRS(mbl vpdfl pdf1d clsfy vimt ipts vil3d vimt3d mvl2 m23d mmn mcal)
SUBDIRS(mipa msm msdi mfpf fhs)

IF (BUILD_UNMAINTAINED_LIBRARIES)
  SUBDIRS(mil mil3d)
ENDIF (BUILD_UNMAINTAINED_LIBRARIES) 

OPTION(BUILD_MUL_TOOLS "Build the MUL tools?" YES)

IF ( BUILD_MUL_TOOLS )
  SUBDIRS( tools )
ENDIF ( BUILD_MUL_TOOLS )

=== contrib/oul/CMakeLists.txt ===
# ./oul/CMakeLists.txt

PROJECT( oul )

doxygen_add_package(contrib/oul "Otago University Libraries")

SET( OUL_INCLUDE_DIR ${oul_SOURCE_DIR} CACHE INTERNAL "Otago University package include files" )
SET( OUL_INSTALL_INCLUDE_DIR 
  ${CMAKE_INSTALL_PREFIX}/include/vxl/contrib/oul
  CACHE INTERNAL "Otago University package include files"
)

INCLUDE_DIRECTORIES( ${VXLCORE_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${OUL_INCLUDE_DIR} )

SET(oul_sources oul_copyright.h)
INSTALL_NOBASE_HEADER_FILES(/include/vxl/contrib/oul ${oul_sources})

SUBDIRS(ouel ouml)
# V4L has been removed in 2.6.38
CHECK_INCLUDE_FILE("linux/videodev.h" OUL_HAVE_LINUX_VIDEODEV_H)
IF(OUL_HAVE_LINUX_VIDEODEV_H)
IF(CMAKE_SYSTEM MATCHES "Linux*")
  SUBDIRS(oufgl)
ENDIF(CMAKE_SYSTEM MATCHES "Linux*")
ENDIF(OUL_HAVE_LINUX_VIDEODEV_H)

=== contrib/tbl/CMakeLists.txt ===
PROJECT( tbl )

doxygen_add_book(contrib/tbl "The Image Processing Library")

doxygen_add_package(contrib/tbl "Image Processing Libraries")

SET( TBL_INCLUDE_DIR ${tbl_SOURCE_DIR} CACHE STATIC "TB package include files" )
SET( TBL_INSTALL_INCLUDE_DIR
  ${CMAKE_INSTALL_PREFIX}/include/vxl/contrib/tbl
  CACHE INTERNAL "TB package include files"
)

INCLUDE_DIRECTORIES(${VXLCORE_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${TBL_INCLUDE_DIR})

SUBDIRS(vipl vepl vepl1)

=== core/examples/CMakeLists.txt ===
ADD_EXECUTABLE(  example_create_image_vil
   create_image_vil.cxx
)
TARGET_LINK_LIBRARIES( example_create_image_vil vul vil )

SUBDIRS( vnl_calc )

=== core/testlib/CMakeLists.txt ===
# ./vxl/testlib/CMakeLists.txt

doxygen_add_library(core/testlib
  PACKAGE core-test
  DESCRIPTION "Testing Library"
  )

FIND_FILE(TESTLIB_VCL_WHERE_ROOT_DIR_H
          vcl_where_root_dir.h
          ${vxl_BINARY_DIR}/vcl )

IF (TESTLIB_VCL_WHERE_ROOT_DIR_H)
  ADD_DEFINITIONS(-DVCL_WHERE_ROOT_DIR_H_EXISTS)
ENDIF(TESTLIB_VCL_WHERE_ROOT_DIR_H)

SET( testlib_sources

  # Useful utilities for the tests
  testlib_test.h                testlib_test.cxx

  # For use by the driver program
  testlib_register.h

  # The main function of the driver executable
  testlib_main.cxx

  # Used to locate test files in source tree
  testlib_root_dir.h            testlib_root_dir.cxx
)

ADD_LIBRARY( testlib ${testlib_sources} )
TARGET_LINK_LIBRARIES( testlib vcl )
INSTALL_TARGETS( /lib testlib)
INSTALL_NOBASE_HEADER_FILES(/include/vxl/core/testlib ${testlib_sources})

IF( BUILD_TESTING )
  SUBDIRS( tests )
ENDIF( BUILD_TESTING )

=== core/vcsl/CMakeLists.txt ===
# vxl/vcsl/CMakeLists.txt

doxygen_add_library(core/vcsl
  DEPENDS core/vnl core/vbl
  PACKAGE core-L2
  DESCRIPTION "Spatial Coordinate Systems and Manipulation"
  )

  SET( vcsl_sources
    vcsl_dimension.h vcsl_dimension_sptr.h
    vcsl_length.cxx vcsl_length.h vcsl_length_sptr.h

    vcsl_angle.cxx vcsl_angle.h vcsl_angle_sptr.h

    vcsl_unit.h vcsl_unit_sptr.h
    vcsl_length_unit.cxx vcsl_length_unit.h vcsl_length_unit_sptr.h
    vcsl_meter.cxx vcsl_meter.h vcsl_meter_sptr.h
    vcsl_millimeter.cxx vcsl_millimeter.h vcsl_millimeter_sptr.h
    vcsl_micron.cxx vcsl_micron.h vcsl_micron_sptr.h

    vcsl_angle_unit.cxx vcsl_angle_unit.h vcsl_angle_unit_sptr.h
    vcsl_radian.cxx vcsl_radian.h vcsl_radian_sptr.h
    vcsl_degree.cxx vcsl_degree.h vcsl_degree_sptr.h

    vcsl_axis.cxx vcsl_axis.h vcsl_axis_sptr.h
    vcsl_coordinate_system.cxx vcsl_coordinate_system.h vcsl_coordinate_system_sptr.h

    vcsl_cartesian.h vcsl_cartesian_sptr.h

    vcsl_spatial.cxx vcsl_spatial.h vcsl_spatial_sptr.h
    vcsl_graph.cxx vcsl_graph.h vcsl_graph_sptr.h

    vcsl_cartesian_2d.cxx vcsl_cartesian_2d.h vcsl_cartesian_2d_sptr.h
    vcsl_cartesian_3d.cxx vcsl_cartesian_3d.h vcsl_cartesian_3d_sptr.h

    vcsl_polar.cxx vcsl_polar.h vcsl_polar_sptr.h
    vcsl_cylindrical.cxx vcsl_cylindrical.h vcsl_cylindrical_sptr.h
    vcsl_spherical.cxx vcsl_spherical.h vcsl_spherical_sptr.h

    vcsl_spheroid.cxx vcsl_spheroid.h vcsl_spheroid_sptr.h
    vcsl_geographic.cxx vcsl_geographic.h vcsl_geographic_sptr.h
    vcsl_utm.cxx vcsl_utm.h vcsl_utm_sptr.h
    vcsl_geocentric.cxx vcsl_geocentric.h vcsl_geocentric_sptr.h
    vcsl_geodetic.h vcsl_geodetic_sptr.h
    vcsl_lambertian.cxx vcsl_lambertian.h vcsl_lambertian_sptr.h

    vcsl_spatial_transformation.cxx vcsl_spatial_transformation.h vcsl_spatial_transformation_sptr.h

    vcsl_composition.cxx vcsl_composition.h vcsl_composition_sptr.h
    vcsl_scale.cxx vcsl_scale.h vcsl_scale_sptr.h
    vcsl_translation.cxx vcsl_translation.h vcsl_translation_sptr.h
    vcsl_rotation.cxx vcsl_rotation.h vcsl_rotation_sptr.h
    vcsl_displacement.cxx vcsl_displacement.h vcsl_displacement_sptr.h

    vcsl_cylindrical_to_cartesian_3d.cxx vcsl_cylindrical_to_cartesian_3d.h vcsl_cylindrical_to_cartesian_3d_sptr.h

    vcsl_perspective.cxx vcsl_perspective.h vcsl_perspective_sptr.h

    vcsl_matrix.cxx vcsl_matrix.h vcsl_matrix_sptr.h
    vcsl_matrix_param.h vcsl_matrix_param_sptr.h
  )

  AUX_SOURCE_DIRECTORY( Templates vcsl_sources )

  ADD_LIBRARY( vcsl ${vcsl_sources} )
  TARGET_LINK_LIBRARIES( vcsl vnl vbl )

  INSTALL_TARGETS(/lib vcsl)
  INSTALL_NOBASE_HEADER_FILES(/include/vxl/core/vcsl ${vcsl_sources})

  IF( BUILD_EXAMPLES )
    SUBDIRS( examples )
  ENDIF( BUILD_EXAMPLES )

  IF( BUILD_TESTING )
    SUBDIRS(tests)
  ENDIF( BUILD_TESTING )

=== core/vgl/CMakeLists.txt ===
# core/vgl/CMakeLists.txt

SET( vgl_sources
  # General
  vgl_fwd.h
  vgl_tolerance.h                vgl_tolerance.txx
  vgl_box_2d.h                   vgl_box_2d.txx
  vgl_box_3d.h                   vgl_box_3d.txx
  vgl_vector_2d.h                vgl_vector_2d.txx
  vgl_vector_3d.h                vgl_vector_3d.txx
  vgl_1d_basis.h                 vgl_1d_basis.cxx  vgl_1d_basis.txx
  vgl_homg.h                     vgl_homg.cxx

  # Points
  vgl_homg_point_1d.h            vgl_homg_point_1d.txx
  vgl_point_2d.h                 vgl_point_2d.txx
  vgl_homg_point_2d.h            vgl_homg_point_2d.txx
  vgl_point_3d.h                 vgl_point_3d.txx
  vgl_homg_point_3d.h            vgl_homg_point_3d.txx

  # Lines
  vgl_line_2d.h                  vgl_line_2d.txx
  vgl_homg_line_2d.h             vgl_homg_line_2d.txx
  vgl_homg_line_3d_2_points.h    vgl_homg_line_3d_2_points.txx
  vgl_line_3d_2_points.h         vgl_line_3d_2_points.txx
  vgl_line_segment_2d.h          vgl_line_segment_2d.txx
  vgl_line_segment_3d.h          vgl_line_segment_3d.txx
  vgl_infinite_line_3d.h         vgl_infinite_line_3d.txx
  vgl_ray_3d.h                   vgl_ray_3d.txx

  # Other curves
  vgl_conic.h                    vgl_conic.txx
  vgl_conic_segment_2d.h         vgl_conic_segment_2d.txx
  vgl_polygon.h                  vgl_polygon.txx
  vgl_sphere_3d.h                vgl_sphere_3d.txx
  vgl_cylinder.h                 vgl_cylinder.txx
  
  # Planes
  vgl_plane_3d.h                 vgl_plane_3d.txx
  vgl_homg_plane_3d.h            vgl_homg_plane_3d.txx

  # Functions
  vgl_closest_point.h            vgl_closest_point.txx
  vgl_distance.h                 vgl_distance.txx
  vgl_clip.h                     vgl_clip.txx
  vgl_area.h                     vgl_area.txx
  vgl_convex.h                   vgl_convex.txx
  vgl_intersection.h             vgl_intersection.txx

  vgl_lineseg_test.h             vgl_lineseg_test.txx
  vgl_triangle_test.h            vgl_triangle_test.txx
  vgl_polygon_test.h             vgl_polygon_test.txx
  vgl_triangle_3d.h              vgl_triangle_3d.cxx

  vgl_region_scan_iterator.h
  vgl_triangle_scan_iterator.h   vgl_triangle_scan_iterator.txx
  vgl_window_scan_iterator.h     vgl_window_scan_iterator.txx
  vgl_polygon_scan_iterator.h    vgl_polygon_scan_iterator.txx
  vgl_ellipse_scan_iterator.h    vgl_ellipse_scan_iterator.txx
)

IF( BUILD_NONCOMMERCIAL )
SET( vgl_sources ${vgl_sources}
  # internals
  internals/gpc.h                internals/gpc.c
)
ENDIF( BUILD_NONCOMMERCIAL )

AUX_SOURCE_DIRECTORY(Templates vgl_sources)

ADD_LIBRARY(vgl ${vgl_sources})
TARGET_LINK_LIBRARIES( vgl vcl )
doxygen_add_library(core/vgl
  #DEPENDS core/vsl core/vnl
  PACKAGE core
  DESCRIPTION "Geometry Library"
  )

INSTALL_TARGETS(/lib vgl)
INSTALL_NOBASE_HEADER_FILES(/include/vxl/core/vgl ${vgl_sources})

SUBDIRS( algo )

IF( BUILD_EXAMPLES )
  SUBDIRS( examples )
ENDIF( BUILD_EXAMPLES )

IF( BUILD_TESTING )
  SUBDIRS(tests)
ENDIF( BUILD_TESTING )

=== core/vpdl/CMakeLists.txt ===
# core/vpdl/CMakeLists.txt
# Vision Probability Distribution Library

doxygen_add_library(core/vpdl
  DEPENDS core/vnl/algo core/vnl
  PACKAGE core-L2E
  DESCRIPTION "Probability Distribution Library"
  )

SET( vpdl_sources
  vpdl_distribution.h      vpdl_distribution.txx

  vpdl_gaussian_base.h
  vpdl_gaussian_sphere.h
  vpdl_gaussian_indep.h
  vpdl_gaussian.h

  vpdl_multi_cmp_dist.h
  vpdl_mixture.h
  vpdl_mixture_of.h
  vpdl_kernel_base.h
  vpdl_kernel_gaussian_sfbw.h

  # Template Library headers
  vpdt/vpdt_access.h
  vpdt/vpdt_enable_if.h
  vpdt/vpdt_field_traits.h
  vpdt/vpdt_field_default.h
  vpdt/vpdt_dist_traits.h
  vpdt/vpdt_probability.h
  vpdt/vpdt_log_probability.h
  vpdt/vpdt_num_obs.h

  vpdt/vpdt_norm_metric.h
  vpdt/vpdt_eigen_sym_matrix.h
  vpdt/vpdt_gaussian.h
  vpdt/vpdt_mixture_of.h
  vpdt/vpdt_update_gaussian.h
  vpdt/vpdt_update_mog.h
  vpdt/vpdt_mog_fitness.h

  vpdt/vpdt_distribution_accessors.h
  vpdt/vpdt_mixture_accessors.h
  vpdt/vpdt_gaussian_detector.h
  vpdt/vpdt_mixture_detector.h
)

AUX_SOURCE_DIRECTORY(Templates vpdl_sources)

ADD_LIBRARY(vpdl ${vpdl_sources})
TARGET_LINK_LIBRARIES( vpdl vnl_algo vnl )

INSTALL_TARGETS(/lib vpdl)
INSTALL_NOBASE_HEADER_FILES(/include/vxl/core/vpdl ${vpdl_sources})

IF( BUILD_TESTING )
  SUBDIRS(tests)
ENDIF( BUILD_TESTING )

=== debian/changelog ===
vxl (1.17.0.dfsg2-4) unstable; urgency=medium

  * Team upload.
  * Switch build dep on libdcmtk2-dev with unversioned libdcmtk-dev.

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 16 Jan 2016 12:38:18 +0000

vxl (1.17.0.dfsg2-3) unstable; urgency=medium

  * lintian issues
  * Apply upstream patch to add general number of platforms
    Closes: #745535
  * Replace deprecated FFmpeg API (Thanks for the patch to Andreas Cadhalpun)
    Closes: #803871

 -- Andreas Tille <tille@debian.org>  Wed, 02 Dec 2015 17:38:08 +0100

vxl (1.17.0.dfsg2-2) unstable; urgency=medium

  * Rename library packages for g++5 ABI transition
    Closes: #799653

 -- Andreas Tille <tille@debian.org>  Mon, 21 Sep 2015 15:34:14 +0200

vxl (1.17.0.dfsg2-1) unstable; urgency=medium

  * Fix remaining DEP5 issues
  * removing lena icon
    Closes: #793154

 -- Andreas Tille <tille@debian.org>  Wed, 29 Jul 2015 08:23:34 +0200

vxl (1.17.0.dfsg-2) unstable; urgency=medium

  * cme fix dpkg-control
  * Apply patch from fedora (Thanks to Brett Johnson <brett@hp.com> for
    forwarding)
    Closes: #778165
  * Unset Cmake variables on configuration change (thanks for the patch to
    Andreas Cadhalpun <andreas.cadhalpun@googlemail.com>)
    Closes: #788559
  * DEP5 fixes

 -- Andreas Tille <tille@debian.org>  Wed, 15 Jul 2015 17:11:41 +0200

=== debian/control ===
Source: vxl
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               freeglut3-dev,
               libavcodec-dev (>= 6:10~),
               libavfilter-dev,
               libavformat-dev (>= 6:10~),
               libavifile-0.7-dev,
               libbz2-dev,
               libcoin80-dev,
               libdc1394-22-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
               libdcmtk-dev,
               libexpat-dev,
               libgeotiff-dev,
               libtiff-dev,
               libglu-dev,
               libjpeg-dev,
               libmpeg2-4-dev,
               libpng-dev,
               libqt4-dev,
               libqt4-opengl-dev,
               libshp-dev,
               libswscale-dev (>= 6:10~),
               libxerces-c-dev,
               ocl-icd-opencl-dev,
               opencl-headers,
               python-dev,
               zlib1g-dev
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/vxl/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/vxl/trunk/
Homepage: http://vxl.sf.net
X-Python-Version: 2.7

Package: libvxl1.17v5
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Conflicts: libvxl1.17
Replaces: libvxl1.17
Pre-Depends: ${misc:Pre-Depends}
Description: C++ Libraries for Computer Vision Research
 VXL (the Vision-something-Libraries) is a collection of C++ libraries
 designed for computer vision research and implementation. It was created
 from TargetJr and the IUE with the aim of making a light, fast and
 consistent system. VXL is written in ANSI/ISO C++ and is designed to be
 portable over many platforms.

Package: libvxl1-dev
Architecture: any
Section: libdevel
Depends: libvxl1.17v5 (= ${binary:Version}),
         ${misc:Depends}
Provides: libvxl-dev
Description: C++ Libraries for Computer Vision Research (development files)
 VXL (the Vision-something-Libraries) is a collection of C++ libraries
 designed for computer vision research and implementation. It was created
 from TargetJr and the IUE with the aim of making a light, fast and
 consistent system. VXL is written in ANSI/ISO C++ and is designed to be
 portable over many platforms.
 .
 This package contains the development files needed to build your own
 VXL applications.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

# http://bugs.debian.org/718047
# -> debian-release team blessing: http://bugs.debian.org/728574#18
ifneq ($(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU ), ia64)
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
endif

VER_FULL = $(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d-)
SOVERSION = $(shell echo $(VER_FULL) | cut -f1-2 -d.)
VER_MAJOR = $(shell echo $(VER_FULL) | cut -f1   -d.)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

UPSTREAM_SRC = vxl-$(VER_FULL)
DEBIAN_SRC_DIR = vxl-$(VER_FULL)
DEBIAN_SRC_TAR = vxl_$(VER_FULL).orig.tar.gz

PYTHON_INCLUDE_DIRS=$(shell python-config --includes | cut -f1 -d' '|cut -c3-)
PYTHON_INCLUDE_DIR="$(PYTHON_INCLUDE_DIRS)"
# See bug #709181
PYTHON_INCLUDE_DIRS2=$(shell python-config --includes | cut -f2 -d' '|cut -c3-)
PYTHON_INCLUDE_DIR2="$(PYTHON_INCLUDE_DIRS2)"
PYTHON_CONFIG_DIR=$(shell python-config --configdir)
PYTHON_LIBRARY="$(PYTHON_CONFIG_DIR)/libpython2.7.so"

# CMAKE_SKIP_RPATH=OFF is required when BUILD_TESTING=ON
# Do not set CMAKE_BUILD_TYPE / http://bugs.debian.org/711515
CMAKE_EXTRA_FLAGS = \
	-DCMAKE_INSTALL_PREFIX:PATH=/usr \
	-DCMAKE_BUILD_TYPE:STRING="" \
	-DCMAKE_SKIP_RPATH:BOOL=OFF \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DAVIFILE_INCLUDE_DIR:PATH=/usr/include/avifile-0.7 \
	-DVXL_USING_NATIVE_ZLIB:BOOL=ON \
	-DVXL_USING_NATIVE_JPEG:BOOL=ON \
	-DVXL_USING_NATIVE_BZLIB2:BOOL=ON \
	-DVXL_USING_NATIVE_MPEG2:BOOL=ON \
	-DVXL_USING_NATIVE_PNG:BOOL=ON \
	-DVXL_USING_NATIVE_TIFF:BOOL=ON \
	-DVXL_USING_NATIVE_SHAPELIB:BOOL=ON \
	-DVXL_USING_NATIVE_GEOTIFF:BOOL=ON \
	-DVXL_USING_NATIVE_EXPAT:BOOL=ON \
	-DBUILD_VGUI:BOOL=ON \
	-DBUILD_BGUI3D:BOOL=ON \
	-DVXL_BUILD_DCMTK:BOOL=ON \
	-DBUILD_OXL:BOOL=ON \
	-DBUILD_CORE_GEOMETRY:BOOL=ON \
	-DBUILD_CORE_IMAGING:BOOL=ON \
	-DBUILD_CORE_NUMERICS:BOOL=ON \
	-DBUILD_CORE_PROBABILITY:BOOL=ON \
	-DBUILD_CORE_SERIALISATION:BOOL=ON \
	-DBUILD_CORE_UTILITIES:BOOL=ON \
	-DBUILD_CORE_VIDEO:BOOL=ON \
	-DBUILD_EXAMPLES:BOOL=OFF \
	-DPYTHON_INCLUDE_DIR=$(PYTHON_INCLUDE_DIR) \
	-DPYTHON_INCLUDE_DIR2=$(PYTHON_INCLUDE_DIR2) \
	-DPYTHON_LIBRARY=$(PYTHON_LIBRARY) \
	-DBUILD_TESTING:BOOL=ON

pkg_lib = libvxl$(SOVERSION)v5
pkg_dev = libvxl$(VER_MAJOR)-dev
#pkg_examples = vxl$(VER_MAJOR)-examples

%:
	dh $@ --buildsystem=cmake --parallel --with python2

override_dh_auto_configure:
	# remove duplicate from boxm_block+boct_tree+short.vnl_vector_fixed+float
	rm -f $(CURDIR)/contrib/brl/bseg/boxm/pro/Templates/boxm_scene+boct_tree+short.vnl_vector_fixed+float.3---.cxx
	dh_auto_configure # See bug: 708131
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_lintian:
	echo "$(pkg_lib): package-name-doesnt-match-sonames" > debian/$(pkg_lib).lintian-overrides
	dh_lintian

override_dh_install:
	dh_install -p$(pkg_lib) debian/tmp/usr/lib/lib*.so.* usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/lib*.so usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/vxl/cmake/*.cmake 

# too many tests failure, with erratic behavior
# http://bugs.debian.org/671601
override_dh_auto_test:
	dh_auto_test || true

get-orig-source:
	uscan --verbose --force-download --repack --compress xz

=== debian/watch ===
version=3
# note: '+dfsg' does not work since vxl refuses to build if a '+' sign is in the path
# see https://lists.debian.org/debian-med/2014/08/msg00087.html
opts="repacksuffix=.dfsg,dversionmangle=s/\.dfsg//g" \
  http://sf.net/vxl/vxl-([\d\.]+)\.tar.gz
